﻿Type=StaticCode
Version=3
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

	Public LogOn As Boolean = True
End Sub

Public Sub CreateUUID As String
	Dim r As Reflector
	r.Target = r.RunStaticMethod("java.util.UUID", "randomUUID", Null, Null)
	Return r.RunMethod("toString")
End Sub

Public Sub GetDeviceId As String
   Dim r As Reflector
   Dim Api As Int
   Api = r.GetStaticField("android.os.Build$VERSION", "SDK_INT")
   If Api < 9 Then
      'Old device
      If File.Exists(File.DirInternal, "__id") Then
         Return File.ReadString(File.DirInternal, "__id")
      Else
         Dim id As Int
         id = Rnd(0x10000000, 0x7FFFFFFF)
         File.WriteString(File.DirInternal, "__id", id)
         Return id
      End If
   Else
      'New device
      Return r.GetStaticField("android.os.Build", "SERIAL")
   End If
End Sub

' Adds or updates items to a Map or creates and fills a new map.
' To create a new Map, pass Null for the ExistingMap parameter.
' KeyList and ValueList must be the same size.
Sub AddToMap(KeyList As List, ValueList As List, ExistingMap As Map) As Map
    Private mapResult As Map : mapResult.Initialize
   
    If ExistingMap.IsInitialized Then
        mapResult = ExistingMap
    End If
   
    For i = 0 To KeyList.Size - 1
        mapResult.Put(KeyList.Get(i), ValueList.Get(i))
    Next
   
    Return mapResult
End Sub


Public Sub LogSub(ModuleName As String, RoutineName As String)
	If Not(LogOn) Then Return
	Log(NowDateTime & " - [" & ModuleName & "." & RoutineName & "]")
End Sub

Public Sub LogSubNoTime(ModuleName As String, RoutineName As String)
	If Not(LogOn) Then Return
	Log("[" & ModuleName & "." & RoutineName & "]")
End Sub

' USES: DateAndTime
Public Sub NowDateTime As String
	Return DateAndTime(DateTime.Now)
End Sub

Public Sub DateAndTime(Ticks As Long) As  String
	Return DateTime.Date(Ticks) & "  " & DateTime.Time(Ticks)
End Sub