﻿Type=Class
Version=3
@EndOfDesignText@
'Class module

#Event: Connected
#Event: Closed (Reason As String)

Sub Class_Globals
	Public ws As WebSocket
	Private CallBack As Object
	Private EventName As String
End Sub

Public Sub Initialize (vCallback As Object, vEventName As String)
	CallBack = vCallback
	EventName = vEventName
	ws.Initialize("ws")
End Sub


Private Sub ws_TextMessage(msg As String)
	Try
		Dim jp As JSONParser
		jp.Initialize(msg)
		Dim m As Map = jp.NextObject
		Dim etype As String = m.Get("etype")
		Dim params As List = m.Get("value")
		Dim event As String = m.Get("prop")

		If etype = "runFunction" Then
			CallSub2(CallBack, EventName & "_" & event, params)
		Else If etype = "runFunctionWithResult" Then
			Dim data As Map = CallSub2(CallBack, EventName & "_" & event, params)
			Dim jg As JSONGenerator
			Dim m2 As Map = modUtils.AddToMap(Array As String("type", "data"), _
														 Array As Object("data", data), Null)
			jg.Initialize(m2)
			ws.SendText(jg.ToString)
		End If
	Catch
		Log("TextMessage Error: " & LastException)
	End Try
End Sub

Private Sub ws_Connected
	CallSub(CallBack,  EventName & "_Connected")
End Sub

Private Sub ws_Closed (Reason As String)
	CallSub2(CallBack, EventName & "_Closed", Reason)
End Sub

Public Sub SendEventToServer(Event As String, Data As Map)
	Dim m As Map
	m.Initialize
	m.Put("type", "event")
	m.Put("event", Event)
	m.Put("params", Data)
	Dim jg As JSONGenerator
	jg.Initialize(m)
	ws.SendText(jg.ToString)
End Sub
